Observation Design Tool Services
================================

The Observation Design Tool Services is the server component of the
Observation Design Tool. It provides the web services used by the
Observation Design Tool client to read and manipulate stored
scheduling blocks.

# Quick start
To clone this repository, run

```
git clone --recurse-submodules git@gitlab.com:ska-telescope/oso/ska-oso-odt-services.git
```

To refresh the GitLab Submodule, execute below commands:

```
git submodule update --recursive --remote
git submodule update --init --recursive
```

### Build and test

Install dependencies with Poetry and activate the virtual environment

```
poetry install
poetry shell
```

To build a new Docker image for the OET, run

```
make oci-build
```

Execute the test suite and lint the project with:

```
make python-test
make python-lint
```

To run a helm chart unit tests to verify helm chart configuration:

```
helm plugin install https://github.com/helm-unittest/helm-unittest.git
make k8s-chart-test
```

### Deploy to Kubernetes

Install the Helm umbrella chart into a Kubernetes cluster with ingress enabled:

```
make k8s-install-chart
```

The Swagger UI should be available external to the cluster at `http://<KUBE_HOST>/<KUBE_NAMESPACE>/odt/api/v1/ui/` and the API accesible via the same URL.

If using minikube, `KUBE_HOST` can be found by running `minikube ip`. 
`KUBE_NAMESPACE` is the namespace the chart was deployed to, likely `ska-db-oda`

To run the component tests in a k8s pod:

```
make k8s-test
```

To uninstall the chart, run

```
make k8s-uninstall-chart
```

# Deployments from CICD

### Deploying to non-production environments

There are 3 different environments which are defined through the standard pipeline templates. They need to be manually triggered in the Gitlab UI.

1. `dev` - a temporary (4 hours) deployment from a feature branch, using the artefacts built in the branch pipeline
2. `integration` - a permanent deployment from the main branch, using the latest version of the artefacts built in the main pipeline
3. `staging` - a permanent deployment of the latest published artefact from CAR

To find the URL for the environment, see the 'info' job of the CICD pipeline stage, which should output the URL alongside the status of the Kubernetes pods.
Generally the API URL should be available at  `https://k8s.stfc.skao.int/$KUBE_NAMESPACE/odt/api/v1`


# Development

The API for this service is defined by an [OpenAPI document](src/ska_oso_odt_services/openapi/odt-openapi-v1.yaml).
This had been used to generate parts of the code used by the application using Swagger Codegen, name those in the [generated package](src/ska_oso_odt_services/generated)
As the data models used by SKA evolve, the component in the OpenAPI document should be updated, and new Python models can be generated by running `make models`. Please do not update these files manually.

By default, the ODT backend delegates all responsibility for SKA ID generation to the SKUID ID generator service and
expects the SKUID ID  generation network service to be available, configured correctly, and for the `SKUID_URL`
environment variable to be  declared in the context of the ODT backend pod. The ODT Helm charts should set the correct
value of `SKUID_URL` automatically. To run the ODT backend without connecting to the SKUID service, declare a
`FAKE_SKUID` variable with any value, which will make the ODT use a local ID generator service.


# Documentation

[![Documentation Status](https://readthedocs.org/projects/ska-telescope-ska-oso-odt-services/badge/?version=latest)](https://developer.skao.int/projects/ska-oso-odt-services/en/latest/?badge=latest)

Documentation can be found in the ``docs`` folder. To build docs, install the
documentation specific requirements:

```
pip3 install sphinx sphinx-rtd-theme recommonmark sphinxcontrib-openapi mistune==0.8.4
```

and build the documentation (will be built in docs/build folder) with

```
make docs-build html
```
